Index: /NEMO/trunk/src/OCE/DOM/dtatsd.F90
===================================================================
--- /NEMO/trunk/src/OCE/DOM/dtatsd.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/DOM/dtatsd.F90	(revision 14189)
@@ -212,5 +212,4 @@
          ENDIF
          !
-         ! NOTE: [tiling-comms-merge] This fix was necessary to take out tra_adv lbc_lnk statements in the zps case, but did not work in the zco case
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )                  ! vertical interpolation of T & S
             DO jk = 1, jpk                        ! determines the intepolated T-S profiles at each (i,j) points
@@ -248,5 +247,4 @@
          !
          IF( ln_zps ) THEN                      ! zps-coordinate (partial steps) interpolation at the last ocean level
-            ! NOTE: [tiling-comms-merge] This fix was necessary to take out tra_adv lbc_lnk statements in the zps case
             DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
                ik = mbkt(ji,jj)
Index: /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/LDF/ldfc1d_c2d.F90	(revision 14189)
@@ -140,5 +140,4 @@
          END_2D
       CASE( 'TRA' )                       ! U- and V-points
-         ! NOTE: [tiling-comms-merge] Change needed to preserve results with respect to the trunk
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
             pah1(ji,jj,1) = pUfac * MAX( e1u(ji,jj), e2u(ji,jj) )**knn
Index: /NEMO/trunk/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/trunk/src/OCE/LDF/ldftra.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/LDF/ldftra.F90	(revision 14189)
@@ -427,5 +427,4 @@
          zaht_min = 0.2_wp * aht0                                       ! minimum value for aht
          zDaht    = aht0 - zaht_min
-         ! NOTE: [tiling-comms-merge] Change needed to preserve results with respect to the trunk
          DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
             !!gm CAUTION : here we assume lat/lon grid in 20deg N/S band (like all ORCA cfg)
Index: /NEMO/trunk/src/OCE/TRA/traadv.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traadv.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traadv.F90	(revision 14189)
@@ -175,5 +175,4 @@
          ENDIF
          !
-         ! NOTE: [tiling-comms-merge] These lbc_lnk calls are still needed (pts in the zco case because zps_hde is not called in step, zuu/zvv/zww in all cases, I think because DO loop bounds need to be updated in DYN as done in TRA)
          SELECT CASE ( nadv )                      !==  compute advection trend and add it to general trend  ==!
          !
@@ -194,5 +193,4 @@
             END IF
          CASE ( np_MUS )                                 ! MUSCL
-            ! NOTE: [tiling-comms-merge] I added this lbc_lnk as it did not validate against the trunk when using ln_zco
             IF (nn_hls.EQ.2) THEN
                 CALL lbc_lnk( 'traadv', pts(:,:,:,:,Kbb), 'T', 1.)
Index: /NEMO/trunk/src/OCE/TRA/traadv_fct.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traadv_fct.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traadv_fct.F90	(revision 14189)
@@ -82,5 +82,4 @@
       REAL(wp)                                 , INTENT(in   ) ::   p2dt            ! tracer time-step
       ! TEMP: [tiling] This can be A2D(nn_hls) if using XIOS (subdomain support)
-      ! NOTE: [tiling-comms-merge] These were changed to INTENT(inout) but they are not modified, so it is reverted
       REAL(wp), DIMENSION(jpi,jpj,jpk         ), INTENT(in   ) ::   pU, pV, pW      ! 3 ocean volume flux components
       REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt,jpt), INTENT(inout) ::   pt              ! tracers and RHS of tracer equation
@@ -102,5 +101,4 @@
             IF(lwp) WRITE(numout,*) '~~~~~~~~~~~'
          ENDIF
-         ! NOTE: [tiling-comms-merge] Bug fix- move array zeroing out of this IF block
          !
          l_trd = .FALSE.            ! set local switches
@@ -353,6 +351,4 @@
             END_3D
          END IF
-         ! NOTE: [tiling-comms-merge] I tested this
-         ! NOT TESTED - NEED l_trd OR l_hst TRUE
          IF( l_trd .OR. l_hst ) THEN   ! trend diagnostics // heat/salt transport
             ztrdx(:,:,:) = ztrdx(:,:,:) + zwx(:,:,:)  ! <<< add anti-diffusive fluxes
@@ -369,6 +365,4 @@
             !
          ENDIF
-         ! NOTE: [tiling-comms-merge] I tested this
-         ! NOT TESTED - NEED l_ptr TRUE
          IF( l_ptr ) THEN              ! "Poleward" transports
             zptry(:,:,:) = zptry(:,:,:) + zwy(:,:,:)  ! <<< add anti-diffusive fluxes
Index: /NEMO/trunk/src/OCE/TRA/traadv_qck.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traadv_qck.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traadv_qck.F90	(revision 14189)
@@ -92,5 +92,4 @@
       REAL(wp)                                 , INTENT(in   ) ::   p2dt            ! tracer time-step
       ! TEMP: [tiling] This can be A2D(nn_hls) if using XIOS (subdomain support)
-      ! NOTE: [tiling-comms-merge] These were changed to INTENT(inout) but they are not modified, so it is reverted
       REAL(wp), DIMENSION(jpi,jpj,jpk         ), INTENT(in   ) ::   pU, pV, pW      ! 3 ocean volume transport components
       REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt,jpt), INTENT(inout) ::   pt              ! tracers and RHS of tracer equation
Index: /NEMO/trunk/src/OCE/TRA/trabbl.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/trabbl.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/trabbl.F90	(revision 14189)
@@ -141,5 +141,4 @@
          IF( ntile == 0 .OR. ntile == nijtile ) THEN                       ! Do only on the last tile
             ! lateral boundary conditions ; just need for outputs
-            ! NOTE: [tiling-comms-merge] The diagnostic results change along the north fold if this is removed
             CALL lbc_lnk_multi( 'trabbl', utr_bbl, 'U', 1.0_wp , vtr_bbl, 'V', 1.0_wp )
             CALL iom_put( "uoce_bbl", utr_bbl )  ! bbl i-transport
@@ -249,5 +248,4 @@
       DO jn = 1, kjpt                                            ! tracer loop
          !                                                       ! ===========
-         ! NOTE: [tiling-comms-merge] Bug fix- correct order of indices
          DO_2D( isj, 0, isi, 0 )            ! CAUTION start from i=1 to update i=2 when cyclic east-west
             IF( utr_bbl(ji,jj) /= 0.e0 ) THEN            ! non-zero i-direction bbl advection
Index: /NEMO/trunk/src/OCE/TRA/traldf.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traldf.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traldf.F90	(revision 14189)
@@ -92,5 +92,4 @@
             CALL tra_ldf_triad( kt, Kmm, nit000,'TRA', ahtu, ahtv, gtsu, gtsv, gtui, gtvi, pts(:,:,:,:,Kbb), pts(:,:,:,:,Kbb), pts(:,:,:,:,Krhs), jpts,  1 )
          CASE ( np_blp , np_blp_i , np_blp_it )             ! bilaplacian: iso-level & iso-neutral operators
-            ! NOTE: [tiling-comms-merge] This lbc_lnk is still needed in the zco case, because zps_hde is not called in step
             IF(nn_hls.EQ.2) CALL lbc_lnk( 'tra_ldf', pts(:,:,:,:,Kbb), 'T',1.)
             CALL tra_ldf_blp  ( kt, Kmm, nit000,'TRA', ahtu, ahtv, gtsu, gtsv, gtui, gtvi, pts(:,:,:,:,Kbb), pts(:,:,:,:,Krhs),             jpts, nldf_tra )
Index: /NEMO/trunk/src/OCE/TRA/traldf_lap_blp.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traldf_lap_blp.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traldf_lap_blp.F90	(revision 14189)
@@ -158,5 +158,4 @@
          ENDIF
          !
-         ! NOTE: [tiling-comms-merge] Bounds changed to avoid repeating this calculation for overlapping rows when using tiling
          DO_3D( isj, iej, isi, iei, 1, jpkm1 )            !== Second derivative (divergence) added to the general tracer trends  ==!
             pt_rhs(ji,jj,jk,jn) = pt_rhs(ji,jj,jk,jn) + (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)     &
@@ -236,5 +235,4 @@
       END SELECT
       !
-      ! NOTE: [tiling-comms-merge] Needed for both nn_hls as tra_ldf_iso and tra_ldf_triad have not yet been adjusted to work with nn_hls = 2. In the zps case the lbc_lnk in zps_hde handles this, but in the zco case zlap always needs this lbc_lnk. I did try adjusting the bounds in tra_ldf_iso and tra_ldf_triad so this lbc_lnk was only needed for nn_hls = 1, but this was not correct and I did not have time to figure out why
       CALL lbc_lnk( 'traldf_lap_blp', zlap(:,:,:,:) , 'T', 1.0_wp )     ! Lateral boundary conditions (unchanged sign)
       !                                               ! Partial top/bottom cell: GRADh( zlap )
Index: /NEMO/trunk/src/OCE/TRA/tranpc.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/tranpc.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/tranpc.F90	(revision 14189)
@@ -112,5 +112,4 @@
          IF( ntej == Nje0 ) THEN ; iej = nn_hls ; ELSE ; iej = 0 ; ENDIF
          !
-         ! NOTE: [tiling-comms-merge] Bounds changed to avoid repeating this calculation for overlapping rows when using tiling
          DO_2D( isj, iej, isi, iei )                        ! interior column only
             !
Index: /NEMO/trunk/src/OCE/TRA/traqsr.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/traqsr.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/traqsr.F90	(revision 14189)
@@ -137,5 +137,4 @@
       !                         !  before qsr induced heat content  !
       !                         !-----------------------------------!
-      ! NOTE: [tiling-comms-merge] Many DO loop bounds changed (probably more than necessary) to avoid changing results when using tiling. Some bounds were also adjusted to account for those changed in tra_atf
       IF( ntsi == Nis0 ) THEN ; isi = nn_hls ; ELSE ; isi = 0 ; ENDIF    ! Avoid double-counting when using tiling
       IF( ntsj == Njs0 ) THEN ; isj = nn_hls ; ELSE ; isj = 0 ; ENDIF
Index: /NEMO/trunk/src/OCE/TRA/trasbc.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/trasbc.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/trasbc.F90	(revision 14189)
@@ -98,5 +98,4 @@
       ENDIF
       !
-      ! NOTE: [tiling-comms-merge] Many DO loop bounds changed to avoid changing results when using tiling. Some bounds were also adjusted to account for those changed in tra_atf
       IF( ntsi == Nis0 ) THEN ; isi = nn_hls ; ELSE ; isi = 0 ; ENDIF    ! Avoid double-counting when using tiling
       IF( ntsj == Njs0 ) THEN ; isj = nn_hls ; ELSE ; isj = 0 ; ENDIF
@@ -155,5 +154,4 @@
       !
       DO jn = 1, jpts               !==  update tracer trend  ==!
-         ! NOTE: [tiling-comms-merge] This looped over nn_hls, which changes the results when using tiling
          DO_2D( 0, 0, 0, 0 )
             pts(ji,jj,1,jn,Krhs) = pts(ji,jj,1,jn,Krhs) + zfact * ( sbc_tsc_b(ji,jj,jn) + sbc_tsc(ji,jj,jn) )    &
Index: /NEMO/trunk/src/OCE/TRA/trazdf.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/trazdf.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/trazdf.F90	(revision 14189)
@@ -101,5 +101,4 @@
                &          - ztrds(:,:,jk)
          END DO
-         ! NOTE: [tiling-comms-merge] The diagnostic results change along the north fold if this is removed
 !!gm this should be moved in trdtra.F90 and done on all trends
          CALL lbc_lnk_multi( 'trazdf', ztrdt, 'T', 1.0_wp , ztrds, 'T', 1.0_wp )
Index: /NEMO/trunk/src/OCE/TRA/zpshde.F90
===================================================================
--- /NEMO/trunk/src/OCE/TRA/zpshde.F90	(revision 14188)
+++ /NEMO/trunk/src/OCE/TRA/zpshde.F90	(revision 14189)
@@ -124,5 +124,4 @@
       !
       IF( ln_timing )   CALL timing_start( 'zps_hde')
-      ! NOTE: [tiling-comms-merge] Some lbc_lnks in tra_adv and tra_ldf can be taken out in the zps case, because this lbc_lnk is called when zps_hde is called in the stp routine. In the zco case they are still needed.
       IF (nn_hls.EQ.2) THEN
          CALL lbc_lnk( 'zpshde', pta, 'T', 1.0_wp)