Index: /utils/CI/sette_wave/sette.sh
===================================================================
--- /utils/CI/sette_wave/sette.sh	(revision 14205)
+++ /utils/CI/sette_wave/sette.sh	(revision 14206)
@@ -4,8 +4,9 @@
 MAIN_DIR=$(dirname $SETTE_DIR)
 export SETTE_TIMING='no'
+export NOT_USING_QCO='no'
 
 # Parse command-line arguments
 if [ $# -gt 0 ]; then
-  while getopts t:x:cshT option; do 
+  while getopts t:x:cshTq option; do 
      case $option in
         c) export SETTE_CLEAN_CONFIGS='yes'
@@ -32,4 +33,8 @@
            echo "ln_timing will be set to true"
            echo "";;
+	q) export NOT_USING_QCO='yes'
+           echo ""
+           echo "key_qco and key_linssh will NOT be activated"
+           echo "";;
         h | *) echo 'sette.sh with no arguments (in this case all configuration will be tested)'
                echo '-t "CFG1_to_test CFG2_to_test ..." to test some specific configurations'
@@ -37,4 +42,5 @@
                echo '-T to set ln_timing true for all non-AGRIF configurations'
                echo '-c to clean each configuration'
+               echo '-q run without qco environment'
                echo '-s to synchronise the sette MY_SRC and EXP00 with the reference MY_SRC and EXPREF'; exit 42 ;;
      esac
Index: /utils/CI/sette_wave/sette_reference-configurations.sh
===================================================================
--- /utils/CI/sette_wave/sette_reference-configurations.sh	(revision 14205)
+++ /utils/CI/sette_wave/sette_reference-configurations.sh	(revision 14206)
@@ -137,4 +137,9 @@
  then
    export ADD_KEYS="${ADD_KEYS} key_loop_fusion"
+fi
+#
+if [ ${NOT_USING_QCO} == "yes" ]
+ then
+   export DEL_KEYS="${DEL_KEYS} key_qco key_linssh"
 fi
 #
Index: /utils/CI/sette_wave/sette_rpt.sh
===================================================================
--- /utils/CI/sette_wave/sette_rpt.sh	(revision 14205)
+++ /utils/CI/sette_wave/sette_rpt.sh	(revision 14206)
@@ -492,5 +492,5 @@
  echo ""
  echo "   !----restart----!   "
- for restart_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST 
+ for restart_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WVORTEX_ST WICE_AGRIF_ST WSWG_ST
  do
    resttest $NEMO_VALID $restart_test $pass
@@ -500,5 +500,5 @@
  echo ""
  echo "   !----repro----!   "
- for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WORCA2_ICE_OBS_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST
+ for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WORCA2_ICE_OBS_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST WSWG_ST
  do
    reprotest $NEMO_VALID $repro_test $pass
@@ -527,5 +527,5 @@
      echo "REFERENCE directory : $NEMO_VALID_REF at rev $NEMO_REV_REF"
      echo ''
-     for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST
+     for repro_test in WGYRE_PISCES_ST WORCA2_ICE_PISCES_ST WORCA2_OFF_PISCES_ST WAMM12_ST WORCA2_SAS_ICE_ST WAGRIF_DEMO_ST WWED025_ST WISOMIP+_ST WVORTEX_ST WICE_AGRIF_ST WOVERFLOW_ST WLOCK_EXCHANGE_ST WSWG_ST
      do
        runcmpres $NEMO_VALID $repro_test $NEMO_VALID_REF $NEMO_REV_REF $pass
Index: /utils/CI/sette_wave/sette_test-cases.sh
===================================================================
--- /utils/CI/sette_wave/sette_test-cases.sh	(revision 14205)
+++ /utils/CI/sette_wave/sette_test-cases.sh	(revision 14206)
@@ -135,4 +135,10 @@
    export ADD_KEYS="${ADD_KEYS} key_loop_fusion"
 fi
+#
+if [ ${NOT_USING_QCO} == "yes" ]
+ then
+   export DEL_KEYS="${DEL_KEYS} key_qco key_linssh"
+fi
+#
 # Settings which control the use of stand alone servers (only relevant if using xios)
 #
@@ -944,4 +950,159 @@
 fi
 
+
+# ---------
+# SWG
+# ---------
+if [ ${config} == "SWG" ] && [ ${DO_RESTART} == "1" ] && [ ${NOT_USING_QCO} == "no" ] ;  then
+## Restartability tests for SWG
+    if [ $( echo ${CMP_NAM} | grep -ic debug ) -eq 1 ]
+    then
+	ITEND=12
+    else
+	ITEND=1728
+    fi
+    ITRST=$(   printf "%08d" $(( ${ITEND} / 2 )) )
+    export TEST_NAME="LONG"
+    cd ${MAIN_DIR}
+    #
+    # syncronisation if target directory/file exist (not done by makenemo)
+    . ${SETTE_DIR}/all_functions.sh
+    #
+    clean_config SWG SWG_ST 'tests'
+    #
+    sync_config  SWG SWG_ST 'tests'
+    #
+    . ./makenemo -m ${CMP_NAM} -n SWG_ST -a SWG -j 8  add_key "${ADD_KEYS}" del_key "${DEL_KEYS}"
+    cd ${SETTE_DIR}
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=1
+    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi 
+    cd ${EXE_DIR}
+    set_namelist namelist_cfg cn_exp \"SWG_LONG\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend ${ITEND}
+    set_namelist namelist_cfg nn_stock $(( ${ITEND} / 2 ))
+    set_namelist namelist_cfg sn_cfctl%l_runstat .true.	
+	
+    #if [ ${SETTE_TIMING} == "yes" ]  ; then set_namelist namelist_cfg ln_timing .true. ; fi
+    if [ ${USING_MPMD} == "yes" ] ; then
+        set_xio_using_server iodef.xml true
+    else
+        set_xio_using_server iodef.xml false
+    fi
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    
+    cd ${SETTE_DIR}
+    export TEST_NAME="SHORT"
+    . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
+    cd ${EXE_DIR}
+    set_namelist namelist_cfg cn_exp \"SWG_SHORT\"
+    set_namelist namelist_cfg nn_it000 $(( ${ITEND} / 2 + 1 ))
+    set_namelist namelist_cfg nn_itend ${ITEND}
+    set_namelist namelist_cfg nn_stock $(( ${ITEND} / 2 ))
+    set_namelist namelist_cfg sn_cfctl%l_runstat .true.
+    set_namelist namelist_cfg ln_rstart .true.
+    set_namelist namelist_cfg nn_rstctl 2
+    set_namelist namelist_cfg cn_ocerst_in \"SWG_LONG_${ITRST}_restart\"
+      
+    #if [ ${SETTE_TIMING} == "yes" ]  ; then set_namelist namelist_cfg ln_timing .true. ; fi
+    if [ ${USING_MPMD} == "yes" ] ; then
+        set_xio_using_server iodef.xml true
+    else
+        set_xio_using_server iodef.xml false
+    fi
+    if [ $NPROC -eq 1 ] ;  then
+        ln -sf ../LONG/SWG_LONG_${ITRST}_restart.nc .
+    else
+        for (( i=1; i<=$NPROC; i++)) ; do
+            L_NPROC=$(( $i - 1 ))
+            L_NPROC=`printf "%04d\n" ${L_NPROC}`
+            ln -sf ../LONG/SWG_LONG_${ITRST}_restart_${L_NPROC}.nc .
+        done
+    fi
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+fi
+
+if [ ${config} == "SWG" ] && [ ${DO_REPRO} == "1" ] && [ ${NOT_USING_QCO} == "no" ] ;  then
+
+## Reproducibility tests for SWG
+    export TEST_NAME="REPRO_2_3"
+    cd ${MAIN_DIR}
+    cd ${SETTE_DIR}
+    . ./param.cfg
+    . ./all_functions.sh
+    . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=6
+    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
+    cd ${EXE_DIR}
+    set_namelist namelist_cfg cn_exp \"SWG_23\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend ${ITEND}
+    set_namelist namelist_cfg nn_stock ${ITEND}
+    set_namelist namelist_cfg jpni 2
+    set_namelist namelist_cfg jpnj 3
+    set_namelist namelist_cfg sn_cfctl%l_runstat .true.
+    set_namelist namelist_cfg sn_cfctl%l_prtctl .true.
+   
+
+    #if [ ${SETTE_TIMING} == "yes" ]  ; then set_namelist namelist_cfg ln_timing .true. ; fi
+    if [ ${USING_MPMD} == "yes" ] ; then
+       set_xio_using_server iodef.xml true
+    else
+       set_xio_using_server iodef.xml false
+    fi
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+
+    cd ${SETTE_DIR}
+    export TEST_NAME="REPRO_3_2"
+    . ./prepare_exe_dir.sh
+    set_valid_dir
+    clean_valid_dir
+    JOB_FILE=${EXE_DIR}/run_job.sh
+    NPROC=6
+    if [ -f ${JOB_FILE} ] ; then \rm ${JOB_FILE} ; fi
+    cd ${EXE_DIR}
+
+    set_namelist namelist_cfg cn_exp \"SWG_32\"
+    set_namelist namelist_cfg nn_it000 1
+    set_namelist namelist_cfg nn_itend ${ITEND}
+    set_namelist namelist_cfg nn_stock ${ITEND}
+    set_namelist namelist_cfg jpni 3
+    set_namelist namelist_cfg jpnj 2
+    set_namelist namelist_cfg sn_cfctl%l_runstat .true.
+    set_namelist namelist_cfg sn_cfctl%l_prtctl .true.
+
+    #if [ ${SETTE_TIMING} == "yes" ]  ; then set_namelist namelist_cfg ln_timing .true. ; fi
+    if [ ${USING_MPMD} == "yes" ] ; then
+       set_xio_using_server iodef.xml true
+    else
+       set_xio_using_server iodef.xml false
+    fi
+    cd ${SETTE_DIR}
+    . ./prepare_job.sh input_EMPTY.cfg $NPROC ${TEST_NAME} ${MPIRUN_FLAG} ${JOB_FILE} ${NUM_XIOSERVERS} ${NEMO_VALID}
+    cd ${SETTE_DIR}
+    . ./fcm_job.sh $NPROC ${JOB_FILE} ${INTERACT_FLAG} ${MPIRUN_FLAG}
+
+fi
+
+
+
 #----
 done