Index: /vendors/PPR/src/bfun1d.h90
===================================================================
--- /vendors/PPR/src/bfun1d.h90	(revision 14211)
+++ /vendors/PPR/src/bfun1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! BFUN1D.f90: poly. basis-functions for reconstruction.
+    ! BFUN1D.h90: poly. basis-functions for reconstruction.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/ffsl1d.h90
===================================================================
--- /vendors/PPR/src/ffsl1d.h90	(revision 14211)
+++ /vendors/PPR/src/ffsl1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! FFSL1D.f90: upwind-biased flux-reconstruction scheme.
+    ! FFSL1D.h90: upwind-biased flux-reconstruction scheme.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/inv.h90
===================================================================
--- /vendors/PPR/src/inv.h90	(revision 14211)
+++ /vendors/PPR/src/inv.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! INV.f90: block-wise solution of small linear systems.
+    ! INV.h90: block-wise solution of small linear systems.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/oscl1d.h90
===================================================================
--- /vendors/PPR/src/oscl1d.h90	(revision 14211)
+++ /vendors/PPR/src/oscl1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! OSCL1D.f90: "oscillation-indicators" for WENO interp.
+    ! OSCL1D.h90: "oscillation-indicators" for WENO interp.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/p1e.h90
===================================================================
--- /vendors/PPR/src/p1e.h90	(revision 14211)
+++ /vendors/PPR/src/p1e.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! P1E.f90: set edge estimates via degree-1 polynomials.
+    ! P1E.h90: set edge estimates via degree-1 polynomials.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/p3e.h90
===================================================================
--- /vendors/PPR/src/p3e.h90	(revision 14211)
+++ /vendors/PPR/src/p3e.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! P3E.f90: set edge estimates via degree-3 polynomials.
+    ! P3E.h90: set edge estimates via degree-3 polynomials.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/p5e.h90
===================================================================
--- /vendors/PPR/src/p5e.h90	(revision 14211)
+++ /vendors/PPR/src/p5e.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! P5E.f90: set edge estimates via degree-5 polynomials.
+    ! P5E.h90: set edge estimates via degree-5 polynomials.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/pbc.h90
===================================================================
--- /vendors/PPR/src/pbc.h90	(revision 14211)
+++ /vendors/PPR/src/pbc.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! PBC.f90: setup polynomial B.C.'s at domain endpoints.
+    ! PBC.h90: setup polynomial B.C.'s at domain endpoints.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/pcm.h90
===================================================================
--- /vendors/PPR/src/pcm.h90	(revision 14211)
+++ /vendors/PPR/src/pcm.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! PCM.f90: 1d piecewise constant reconstruction .
+    ! PCM.h90: 1d piecewise constant reconstruction .
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/plm.h90
===================================================================
--- /vendors/PPR/src/plm.h90	(revision 14211)
+++ /vendors/PPR/src/plm.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! PLM.f90: a 1d, slope-limited piecewise linear method.
+    ! PLM.h90: a 1d, slope-limited piecewise linear method.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/ppm.h90
===================================================================
--- /vendors/PPR/src/ppm.h90	(revision 14211)
+++ /vendors/PPR/src/ppm.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! PPM.f90: 1d slope-limited, piecewise parabolic recon.
+    ! PPM.h90: 1d slope-limited, piecewise parabolic recon.
     !
     ! Darren Engwirda 
@@ -45,5 +45,4 @@
         &               fdat,fhat,edge,oscl, &
         &               dmin,ilim,wlim,halo)
-
 
     !
Index: /vendors/PPR/src/ppr_1d.F90
===================================================================
--- /vendors/PPR/src/ppr_1d.F90	(revision 14212)
+++ /vendors/PPR/src/ppr_1d.F90	(revision 14212)
@@ -0,0 +1,318 @@
+
+    !
+    ! This program may be freely redistributed under the 
+    ! condition that the copyright notices (including this 
+    ! entire header) are not removed, and no compensation 
+    ! is received through use of the software.  Private, 
+    ! research, and institutional use is free.  You may 
+    ! distribute modified versions of this code UNDER THE 
+    ! CONDITION THAT THIS CODE AND ANY MODIFICATIONS MADE 
+    ! TO IT IN THE SAME FILE REMAIN UNDER COPYRIGHT OF THE 
+    ! ORIGINAL AUTHOR, BOTH SOURCE AND OBJECT CODE ARE 
+    ! MADE FREELY AVAILABLE WITHOUT CHARGE, AND CLEAR 
+    ! NOTICE IS GIVEN OF THE MODIFICATIONS.  Distribution 
+    ! of this code as part of a commercial system is 
+    ! permissible ONLY BY DIRECT ARRANGEMENT WITH THE 
+    ! AUTHOR.  (If you are not directly supplying this 
+    ! code to a customer, and you are instead telling them 
+    ! how they can obtain it for free, then you are not 
+    ! required to make any arrangement with me.) 
+    !
+    ! Disclaimer:  Neither I nor: Columbia University, the 
+    ! National Aeronautics and Space Administration, nor 
+    ! the Massachusetts Institute of Technology warrant 
+    ! or certify this code in any way whatsoever.  This 
+    ! code is provided "as-is" to be used at your own risk.
+    !
+    !
+
+    module ppr_1d
+
+    !    
+    ! PPR-1D.F90: 1-d piecewise polynomial reconstructions.
+    !
+    ! Darren Engwirda 
+    ! 31-Mar-2019
+    ! de2363 [at] columbia [dot] edu
+    !
+    !
+
+    implicit none
+
+    !------------------------------------ method selection !
+        
+    integer, parameter :: p1e_method = +100
+    integer, parameter :: p3e_method = +101
+    integer, parameter :: p5e_method = +102
+
+    integer, parameter :: pcm_method = +200
+    integer, parameter :: plm_method = +201
+    integer, parameter :: ppm_method = +202
+    integer, parameter :: pqm_method = +203
+
+    integer, parameter :: null_limit = +300
+    integer, parameter :: mono_limit = +301
+    integer, parameter :: weno_limit = +302
+
+    integer, parameter :: bcon_loose = +400
+    integer, parameter :: bcon_value = +401
+    integer, parameter :: bcon_slope = +402
+ 
+    type rmap_tics
+    !------------------------------- tCPU timer for RCON1D !
+        integer :: rmap_time
+        integer :: edge_time
+        integer :: cell_time
+        integer :: oscl_time
+    end type rmap_tics
+
+    type rcon_opts
+    !------------------------------- parameters for RCON1D !
+        integer :: edge_meth
+        integer :: cell_meth
+        integer :: cell_lims
+        integer :: wall_lims
+    end type rcon_opts
+
+    type rcon_ends
+    !------------------------------- end-conditions struct !
+        integer :: bcopt
+        real*8  :: value
+        real*8  :: slope
+    end type rcon_ends
+
+    type rcon_work
+    !------------------------------- work-space for RCON1D !
+        real*8, allocatable  :: edge_func(:,:)
+        real*8, allocatable  :: edge_dfdx(:,:)
+        real*8, allocatable  :: cell_oscl(:,:,:)
+    contains
+        procedure :: init => init_rcon_work
+        procedure :: free => free_rcon_work
+    end type rcon_work
+
+    type, extends(rcon_opts) :: rmap_opts
+    !------------------------------- parameters for RMAP1D !
+    end type rmap_opts
+
+    type, extends(rcon_work) :: rmap_work
+    !------------------------------- work-space for RMAP1D !
+        real*8, allocatable  :: cell_spac(:)
+        real*8, allocatable  :: cell_func(:,:,:)
+    contains
+        procedure :: init => init_rmap_work
+        procedure :: free => free_rmap_work
+    end type rmap_work
+
+    contains
+ 
+    !------------------------------------------------------!
+    ! INIT-RCON-WORK: init. work-space for RCON1D.         !
+    !------------------------------------------------------!
+    
+    subroutine init_rcon_work(this,npos,nvar,opts)
+
+    !
+    ! THIS  work-space structure for RCON1D .
+    ! NPOS  no. edges over grid.
+    ! NVAR  no. state variables.
+    ! OPTS  parameters structure for RCON1D .
+    !
+
+        implicit none
+
+    !------------------------------------------- arguments !
+        class(rcon_work) , intent(inout) :: this
+        integer, intent(in):: npos
+        integer, intent(in):: nvar
+        class(rcon_opts) , optional      :: opts
+
+    !------------------------------------------- variables !
+        integer :: okay
+
+        allocate(this% &
+        &   edge_func(  nvar,npos), &
+        &        this% &
+        &   edge_dfdx(  nvar,npos), &
+        &        this% &
+        &   cell_oscl(2,nvar,npos), &
+        &   stat=okay)
+        
+    end subroutine
+
+    !------------------------------------------------------!
+    ! INIT-RMAP-WORK: init. work-space for RMAP1D.         !
+    !------------------------------------------------------!
+    
+    subroutine init_rmap_work(this,npos,nvar,opts)
+
+    !
+    ! THIS  work-space structure for RMAP1D .
+    ! NPOS  no. edges over grid.
+    ! NVAR  no. state variables.
+    ! OPTS  parameters structure for RMAP1D .
+    !
+
+        implicit none
+
+    !------------------------------------------- arguments !
+        class(rmap_work) , intent(inout) :: this
+        integer, intent(in) :: npos
+        integer, intent(in) :: nvar
+        class(rcon_opts) , optional      :: opts
+
+    !------------------------------------------- variables !
+        integer :: okay,ndof
+
+        ndof = ndof1d(opts%cell_meth)
+
+        allocate(this% &
+        &   edge_func(  nvar,npos), &
+        &        this% &
+        &   edge_dfdx(  nvar,npos), &
+        &        this% &
+        &   cell_oscl(2,nvar,npos), &
+        &        this% &
+        &   cell_spac(       npos), &
+        &        this% &
+        &   cell_func(ndof,nvar,npos) , &
+        &   stat=okay)
+ 
+    end subroutine
+
+    !------------------------------------------------------!
+    ! FREE-RCON-WORK: free work-space for RCON1D .         !
+    !------------------------------------------------------!
+    
+    subroutine free_rcon_work(this)
+
+        implicit none
+
+    !------------------------------------------- arguments !
+        class(rcon_work), intent(inout) :: this
+
+        deallocate(this%edge_func, &
+        &          this%edge_dfdx, &
+        &          this%cell_oscl)
+     
+    end subroutine
+
+    !------------------------------------------------------!
+    ! FREE-RMAP-WORK: free work-space for RMAP1D .         !
+    !------------------------------------------------------!
+    
+    subroutine free_rmap_work(this)
+
+        implicit none
+
+    !------------------------------------------- arguments !
+        class(rmap_work), intent(inout) :: this
+
+
+        deallocate(this%edge_func, &
+        &          this%edge_dfdx, &
+        &          this%cell_oscl, &
+        &          this%cell_func, &
+        &          this%cell_spac)
+
+    end subroutine
+
+    !------------------------------------------------------!
+    ! NDOF1D : no. degrees-of-freedom per polynomial .     !
+    !------------------------------------------------------!
+    
+    pure function ndof1d(meth) result(rdof)
+
+        implicit none
+
+    !------------------------------------------- arguments !
+        integer, intent( in) :: meth
+
+    !------------------------------------------- variables !
+        integer  :: rdof
+
+        select case(meth)
+    !-------------------------------- edge reconstructions !
+        case (p1e_method)
+            rdof = +2
+        case (p3e_method)
+            rdof = +4
+        case (p5e_method)
+            rdof = +6
+    !-------------------------------- cell reconstructions !
+        case (pcm_method)
+            rdof = +1
+        case (plm_method)
+            rdof = +2
+        case (ppm_method)
+            rdof = +3
+        case (pqm_method)
+            rdof = +5
+        
+        case default 
+            rdof = +0
+
+        end select
+        
+    end function  ndof1d
+
+    !------------------------------------------------------!
+    ! BFUN1D : one-dimensional poly. basis-functions .     !
+    !------------------------------------------------------!
+        
+#       include "bfun1d.h90"
+
+    !------------------------------------------------------!
+    ! UTIL1D : one-dimensional grid manip. utilities .     !
+    !------------------------------------------------------!
+    
+#       include "util1d.h90"
+
+    !------------------------------------------------------!
+    ! WENO1D : "essentially" non-oscillatory limiter .     !
+    !------------------------------------------------------!
+
+#       include "weno1d.h90"
+
+#       include "oscl1d.h90"
+
+    !------------------------------------------------------!
+    ! RCON1D : one-dimensional poly. reconstructions .     !
+    !------------------------------------------------------!
+
+#       include "rcon1d.h90"
+
+#       include "inv.h90"
+
+#       include "pbc.h90"
+#       include "p1e.h90"
+#       include "p3e.h90"
+#       include "p5e.h90"
+
+#       include "root1d.h90"
+    
+#       include "pcm.h90"
+#       include "plm.h90"
+#       include "ppm.h90"
+#       include "pqm.h90"
+    
+    !------------------------------------------------------!
+    ! RMAP1D : one-dimensional conservative "re-map" .     !
+    !------------------------------------------------------!
+       
+#       include "rmap1d.h90"
+
+    !------------------------------------------------------!
+    ! FFSL1D : one-dimensional FFSL scalar transport .     !
+    !------------------------------------------------------!
+    
+#       include "ffsl1d.h90"
+
+
+    !------------------------------------------ end ppr_1d !
+      
+        
+    end module
+    
+    
+    
Index: ndors/PPR/src/ppr_1d.f90
===================================================================
--- /vendors/PPR/src/ppr_1d.f90	(revision 14211)
+++ 	(revision )
@@ -1,342 +1,0 @@
-
-    !
-    ! This program may be freely redistributed under the 
-    ! condition that the copyright notices (including this 
-    ! entire header) are not removed, and no compensation 
-    ! is received through use of the software.  Private, 
-    ! research, and institutional use is free.  You may 
-    ! distribute modified versions of this code UNDER THE 
-    ! CONDITION THAT THIS CODE AND ANY MODIFICATIONS MADE 
-    ! TO IT IN THE SAME FILE REMAIN UNDER COPYRIGHT OF THE 
-    ! ORIGINAL AUTHOR, BOTH SOURCE AND OBJECT CODE ARE 
-    ! MADE FREELY AVAILABLE WITHOUT CHARGE, AND CLEAR 
-    ! NOTICE IS GIVEN OF THE MODIFICATIONS.  Distribution 
-    ! of this code as part of a commercial system is 
-    ! permissible ONLY BY DIRECT ARRANGEMENT WITH THE 
-    ! AUTHOR.  (If you are not directly supplying this 
-    ! code to a customer, and you are instead telling them 
-    ! how they can obtain it for free, then you are not 
-    ! required to make any arrangement with me.) 
-    !
-    ! Disclaimer:  Neither I nor: Columbia University, the 
-    ! National Aeronautics and Space Administration, nor 
-    ! the Massachusetts Institute of Technology warrant 
-    ! or certify this code in any way whatsoever.  This 
-    ! code is provided "as-is" to be used at your own risk.
-    !
-    !
-
-    module ppr_1d
-
-    !    
-    ! PPR-1D.f90: 1-d piecewise polynomial reconstructions.
-    !
-    ! Darren Engwirda 
-    ! 31-Mar-2019
-    ! de2363 [at] columbia [dot] edu
-    !
-    !
-
-    implicit none
-
-    !------------------------------------ compile-time def !
-
-!   define __PPR_WARNMAT__
-!   define __PPR_DOTIMER__
-
-#   ifdef  __PPR_DOTIMER__
-
-#       define __TIC__                      \
-        call system_clock   (ttic,rate)
-
-#       define __TOC__(time, mark)          \
-        call system_clock   (ttoc,rate) ;   \
-        if ( present(time)) \
-        time%mark=time%mark+(ttoc-ttic)
-    
-#   else
-
-#       define __TIC__
-#       define __TOC__(time, mark)
-
-#   endif
-
-    !------------------------------------ method selection !
-        
-    integer, parameter :: p1e_method = +100
-    integer, parameter :: p3e_method = +101
-    integer, parameter :: p5e_method = +102
-
-    integer, parameter :: pcm_method = +200
-    integer, parameter :: plm_method = +201
-    integer, parameter :: ppm_method = +202
-    integer, parameter :: pqm_method = +203
-
-    integer, parameter :: null_limit = +300
-    integer, parameter :: mono_limit = +301
-    integer, parameter :: weno_limit = +302
-
-    integer, parameter :: bcon_loose = +400
-    integer, parameter :: bcon_value = +401
-    integer, parameter :: bcon_slope = +402
- 
-    type rmap_tics
-    !------------------------------- tCPU timer for RCON1D !
-        integer :: rmap_time
-        integer :: edge_time
-        integer :: cell_time
-        integer :: oscl_time
-    end type rmap_tics
-
-    type rcon_opts
-    !------------------------------- parameters for RCON1D !
-        integer :: edge_meth
-        integer :: cell_meth
-        integer :: cell_lims
-        integer :: wall_lims
-    end type rcon_opts
-
-    type rcon_ends
-    !------------------------------- end-conditions struct !
-        integer :: bcopt
-        real*8  :: value
-        real*8  :: slope
-    end type rcon_ends
-
-    type rcon_work
-    !------------------------------- work-space for RCON1D !
-        real*8, allocatable  :: edge_func(:,:)
-        real*8, allocatable  :: edge_dfdx(:,:)
-        real*8, allocatable  :: cell_oscl(:,:,:)
-    contains
-        procedure :: init => init_rcon_work
-        procedure :: free => free_rcon_work
-    end type rcon_work
-
-    type, extends(rcon_opts) :: rmap_opts
-    !------------------------------- parameters for RMAP1D !
-    end type rmap_opts
-
-    type, extends(rcon_work) :: rmap_work
-    !------------------------------- work-space for RMAP1D !
-        real*8, allocatable  :: cell_spac(:)
-        real*8, allocatable  :: cell_func(:,:,:)
-    contains
-        procedure :: init => init_rmap_work
-        procedure :: free => free_rmap_work
-    end type rmap_work
-
-    contains
- 
-    !------------------------------------------------------!
-    ! INIT-RCON-WORK: init. work-space for RCON1D.         !
-    !------------------------------------------------------!
-    
-    subroutine init_rcon_work(this,npos,nvar,opts)
-
-    !
-    ! THIS  work-space structure for RCON1D .
-    ! NPOS  no. edges over grid.
-    ! NVAR  no. state variables.
-    ! OPTS  parameters structure for RCON1D .
-    !
-
-        implicit none
-
-    !------------------------------------------- arguments !
-        class(rcon_work) , intent(inout) :: this
-        integer, intent(in):: npos
-        integer, intent(in):: nvar
-        class(rcon_opts) , optional      :: opts
-
-    !------------------------------------------- variables !
-        integer :: okay
-
-        allocate(this% &
-        &   edge_func(  nvar,npos), &
-        &        this% &
-        &   edge_dfdx(  nvar,npos), &
-        &        this% &
-        &   cell_oscl(2,nvar,npos), &
-        &   stat=okay)
-        
-    end subroutine
-
-    !------------------------------------------------------!
-    ! INIT-RMAP-WORK: init. work-space for RMAP1D.         !
-    !------------------------------------------------------!
-    
-    subroutine init_rmap_work(this,npos,nvar,opts)
-
-    !
-    ! THIS  work-space structure for RMAP1D .
-    ! NPOS  no. edges over grid.
-    ! NVAR  no. state variables.
-    ! OPTS  parameters structure for RMAP1D .
-    !
-
-        implicit none
-
-    !------------------------------------------- arguments !
-        class(rmap_work) , intent(inout) :: this
-        integer, intent(in) :: npos
-        integer, intent(in) :: nvar
-        class(rcon_opts) , optional      :: opts
-
-    !------------------------------------------- variables !
-        integer :: okay,ndof
-
-        ndof = ndof1d(opts%cell_meth)
-
-        allocate(this% &
-        &   edge_func(  nvar,npos), &
-        &        this% &
-        &   edge_dfdx(  nvar,npos), &
-        &        this% &
-        &   cell_oscl(2,nvar,npos), &
-        &        this% &
-        &   cell_spac(       npos), &
-        &        this% &
-        &   cell_func(ndof,nvar,npos) , &
-        &   stat=okay)
- 
-    end subroutine
-
-    !------------------------------------------------------!
-    ! FREE-RCON-WORK: free work-space for RCON1D .         !
-    !------------------------------------------------------!
-    
-    subroutine free_rcon_work(this)
-
-        implicit none
-
-    !------------------------------------------- arguments !
-        class(rcon_work), intent(inout) :: this
-
-        deallocate(this%edge_func, &
-        &          this%edge_dfdx, &
-        &          this%cell_oscl)
-     
-    end subroutine
-
-    !------------------------------------------------------!
-    ! FREE-RMAP-WORK: free work-space for RMAP1D .         !
-    !------------------------------------------------------!
-    
-    subroutine free_rmap_work(this)
-
-        implicit none
-
-    !------------------------------------------- arguments !
-        class(rmap_work), intent(inout) :: this
-
-
-        deallocate(this%edge_func, &
-        &          this%edge_dfdx, &
-        &          this%cell_oscl, &
-        &          this%cell_func, &
-        &          this%cell_spac)
-
-    end subroutine
-
-    !------------------------------------------------------!
-    ! NDOF1D : no. degrees-of-freedom per polynomial .     !
-    !------------------------------------------------------!
-    
-    pure function ndof1d(meth) result(rdof)
-
-        implicit none
-
-    !------------------------------------------- arguments !
-        integer, intent( in) :: meth
-
-    !------------------------------------------- variables !
-        integer  :: rdof
-
-        select case(meth)
-    !-------------------------------- edge reconstructions !
-        case (p1e_method)
-            rdof = +2
-        case (p3e_method)
-            rdof = +4
-        case (p5e_method)
-            rdof = +6
-    !-------------------------------- cell reconstructions !
-        case (pcm_method)
-            rdof = +1
-        case (plm_method)
-            rdof = +2
-        case (ppm_method)
-            rdof = +3
-        case (pqm_method)
-            rdof = +5
-        
-        case default 
-            rdof = +0
-
-        end select
-        
-    end function  ndof1d
-
-    !------------------------------------------------------!
-    ! BFUN1D : one-dimensional poly. basis-functions .     !
-    !------------------------------------------------------!
-        
-#       include "bfun1d.h90"
-
-    !------------------------------------------------------!
-    ! UTIL1D : one-dimensional grid manip. utilities .     !
-    !------------------------------------------------------!
-    
-#       include "util1d.h90"
-
-    !------------------------------------------------------!
-    ! WENO1D : "essentially" non-oscillatory limiter .     !
-    !------------------------------------------------------!
-
-#       include "weno1d.h90"
-
-#       include "oscl1d.h90"
-
-    !------------------------------------------------------!
-    ! RCON1D : one-dimensional poly. reconstructions .     !
-    !------------------------------------------------------!
-
-#       include "rcon1d.h90"
-
-#       include "inv.h90"
-
-#       include "pbc.h90"
-#       include "p1e.h90"
-#       include "p3e.h90"
-#       include "p5e.h90"
-
-#       include "root1d.h90"
-    
-#       include "pcm.h90"
-#       include "plm.h90"
-#       include "ppm.h90"
-#       include "pqm.h90"
-    
-    !------------------------------------------------------!
-    ! RMAP1D : one-dimensional conservative "re-map" .     !
-    !------------------------------------------------------!
-       
-#       include "rmap1d.h90"
-
-    !------------------------------------------------------!
-    ! FFSL1D : one-dimensional FFSL scalar transport .     !
-    !------------------------------------------------------!
-    
-#       include "ffsl1d.h90"
-
-
-    !------------------------------------------ end ppr_1d !
-      
-#       undef   __TIC__
-#       undef   __TOC__
-        
-    end module
-    
-    
-    
Index: /vendors/PPR/src/pqm.h90
===================================================================
--- /vendors/PPR/src/pqm.h90	(revision 14211)
+++ /vendors/PPR/src/pqm.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! PQM.f90: a 1d slope-limited, piecewise quartic recon.
+    ! PQM.h90: a 1d slope-limited, piecewise quartic recon.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/rcon1d.h90
===================================================================
--- /vendors/PPR/src/rcon1d.h90	(revision 14211)
+++ /vendors/PPR/src/rcon1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! RCON1D.f90: conservative, polynomial reconstructions.
+    ! RCON1D.h90: conservative, polynomial reconstructions.
     !
     ! Darren Engwirda 
@@ -102,5 +102,4 @@
     !-------------------------- compute edge values/slopes !
 
-        __TIC__
 
         if ( (opts%cell_meth.eq.ppm_method) &
@@ -142,9 +141,7 @@
         end if
         
-        __TOC__(tCPU,edge_time)
 
     !-------------------------- compute oscil. derivatives !
 
-        __TIC__
 
         if (opts%cell_lims.eq.weno_limit) then
@@ -157,9 +154,7 @@
         end if
     
-        __TOC__(time,oscl_time)
 
     !-------------------------- compute grid-cell profiles !
 
-        __TIC__
 
         select case (opts%cell_meth)
@@ -201,5 +196,4 @@
         end select
 
-        __TOC__(tCPU,cell_time)
 
     end subroutine
Index: /vendors/PPR/src/rmap1d.h90
===================================================================
--- /vendors/PPR/src/rmap1d.h90	(revision 14211)
+++ /vendors/PPR/src/rmap1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! RMAP1D.f90: high-order integral re-mapping operators.
+    ! RMAP1D.h90: high-order integral re-mapping operators.
     !
     ! Darren Engwirda 
@@ -148,5 +148,4 @@
     !------------- remap FDAT from XPOS to XNEW using FHAT !
 
-        __TIC__
 
         select case(opts%cell_meth)
@@ -185,5 +184,4 @@
         end select
         
-        __TOC__(tCPU,rmap_time)
         
         return
@@ -245,4 +243,9 @@
         integer, parameter :: INTB = -1   ! integral basis  
 
+    !------------------------------------- initializations !
+
+        vvlo(+1:+5) = 0.d0
+        vvhi(+1:+5) = 0.d0
+
     !------------- remap FDAT from XPOS to XNEW using FHAT !
 
Index: /vendors/PPR/src/root1d.h90
===================================================================
--- /vendors/PPR/src/root1d.h90	(revision 14211)
+++ /vendors/PPR/src/root1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! ROOT1D.f90: find the "roots" of degree-k polynomials.
+    ! ROOT1D.h90: find the "roots" of degree-k polynomials.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/util1d.h90
===================================================================
--- /vendors/PPR/src/util1d.h90	(revision 14211)
+++ /vendors/PPR/src/util1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! UTIL1D.f90: util. func. for 1-dim. grid manipulation.
+    ! UTIL1D.h90: util. func. for 1-dim. grid manipulation.
     !
     ! Darren Engwirda 
Index: /vendors/PPR/src/weno1d.h90
===================================================================
--- /vendors/PPR/src/weno1d.h90	(revision 14211)
+++ /vendors/PPR/src/weno1d.h90	(revision 14212)
@@ -28,5 +28,5 @@
 
     !    
-    ! WENO1D.f90: WENO-style slope-limiting for 1d reconst.
+    ! WENO1D.h90: WENO-style slope-limiting for 1d reconst.
     !
     ! Darren Engwirda 