Index: NEMO/trunk/src/OCE/DYN/dynldf_iso.F90
===================================================================
--- NEMO/trunk/src/OCE/DYN/dynldf_iso.F90	(revision 14207)
+++ NEMO/trunk/src/OCE/DYN/dynldf_iso.F90	(revision 14215)
@@ -168,5 +168,5 @@
 
          IF( ln_zps ) THEN      ! z-coordinate - partial steps : min(e3u)
-            DO_2D( 0, 0, 0, 1 )
+            DO_2D( 0, 1, 0, 0 )
                zabe1 = ( ahmt(ji,jj,jk)+rn_ahm_b ) * e2t(ji,jj)   &
                   &    * MIN( e3u(ji  ,jj,jk,Kmm),                &
@@ -183,5 +183,5 @@
             END_2D
          ELSE                   ! other coordinate system (zco or sco) : e3t
-            DO_2D( 0, 0, 0, 1 )
+            DO_2D( 0, 1, 0, 0 )
                zabe1 = ( ahmt(ji,jj,jk)+rn_ahm_b )   &
                   &     * e2t(ji,jj) * e3t(ji,jj,jk,Kmm) * r1_e1t(ji,jj)
@@ -219,5 +219,5 @@
          ! i-flux at f-point              |   t   |
 
-         DO_2D( 0, 0, 1, 0 )
+         DO_2D( 1, 0, 0, 0 )
             zabe1 = ( ahmf(ji,jj,jk) + rn_ahm_b )   &
                &     * e2f(ji,jj) * e3f(ji,jj,jk) * r1_e1f(ji,jj)
@@ -235,5 +235,5 @@
          ! j-flux at t-point
          IF( ln_zps ) THEN      ! z-coordinate - partial steps : min(e3u)
-            DO_2D( 0, 1, 1, 0 )
+            DO_2D( 1, 0, 0, 1 )
                zabe2 = ( ahmt(ji,jj,jk)+rn_ahm_b ) * e1t(ji,jj)   &
                   &     * MIN( e3v(ji,jj  ,jk,Kmm),                 &
@@ -250,5 +250,5 @@
             END_2D
          ELSE                   ! other coordinate system (zco or sco) : e3t
-            DO_2D( 0, 1, 1, 0 )
+            DO_2D( 1, 0, 0, 1 )
                zabe2 = ( ahmt(ji,jj,jk)+rn_ahm_b )   &
                   &     * e1t(ji,jj) * e3t(ji,jj,jk,Kmm) * r1_e2t(ji,jj)
Index: NEMO/trunk/src/OCE/DYN/dynspg_ts.F90
===================================================================
--- NEMO/trunk/src/OCE/DYN/dynspg_ts.F90	(revision 14207)
+++ NEMO/trunk/src/OCE/DYN/dynspg_ts.F90	(revision 14215)
@@ -461,18 +461,18 @@
 #if defined key_qcoTest_FluxForm
             !                                ! 'key_qcoTest_FluxForm' : simple ssh average
-            DO_2D( 1, 1, 1, 0 )   ! not jpi-column
+            DO_2D( 1, 0, 1, 1 )   ! not jpi-column
                zhup2_e(ji,jj) = hu_0(ji,jj) + r1_2 * (  zsshp2_e(ji,jj) + zsshp2_e(ji+1,jj  )  ) * ssumask(ji,jj)
             END_2D
-            DO_2D( 1, 0, 1, 1 )
+            DO_2D( 1, 1, 1, 0 )
                zhvp2_e(ji,jj) = hv_0(ji,jj) + r1_2 * (  zsshp2_e(ji,jj) + zsshp2_e(ji  ,jj+1)  ) * ssvmask(ji,jj)
             END_2D
 #else
             !                                ! no 'key_qcoTest_FluxForm' : surface weighted ssh average
-            DO_2D( 1, 1, 1, 0 )   ! not jpi-column
+            DO_2D( 1, 0, 1, 1 )   ! not jpi-column
                zhup2_e(ji,jj) = hu_0(ji,jj) + r1_2 * r1_e1e2u(ji,jj)                        &
                     &                              * (  e1e2t(ji  ,jj) * zsshp2_e(ji  ,jj)  &
                     &                                 + e1e2t(ji+1,jj) * zsshp2_e(ji+1,jj)  ) * ssumask(ji,jj)
             END_2D
-            DO_2D( 1, 0, 1, 1 )   ! not jpj-row
+            DO_2D( 1, 1, 1, 0 )   ! not jpj-row
                zhvp2_e(ji,jj) = hv_0(ji,jj) + r1_2 * r1_e1e2v(ji,jj)                        &
                     &                              * (  e1e2t(ji,jj  ) * zsshp2_e(ji,jj  )  &
@@ -538,8 +538,8 @@
 #if defined key_qcoTest_FluxForm
             !                                ! 'key_qcoTest_FluxForm' : simple ssh average
+            DO_2D( 1, 0, 1, 1 )
+               zsshu_a(ji,jj) = r1_2 * (  ssha_e(ji,jj) + ssha_e(ji+1,jj  )  ) * ssumask(ji,jj)
+            END_2D
             DO_2D( 1, 1, 1, 0 )
-               zsshu_a(ji,jj) = r1_2 * (  ssha_e(ji,jj) + ssha_e(ji+1,jj  )  ) * ssumask(ji,jj)
-            END_2D
-            DO_2D( 1, 0, 1, 1 )
                zsshv_a(ji,jj) = r1_2 * (  ssha_e(ji,jj) + ssha_e(ji  ,jj+1)  ) * ssvmask(ji,jj)
             END_2D
@@ -1253,5 +1253,5 @@
       !!----------------------------------------------------------------------
       !
-      DO_2D( 1, 1, 1, 0 )   ! not jpi-column
+      DO_2D( 1, 0, 1, 1 )   ! not jpi-column
          IF ( phU(ji,jj) > 0._wp ) THEN   ;   pUmsk(ji,jj) = pTmsk(ji  ,jj) 
          ELSE                             ;   pUmsk(ji,jj) = pTmsk(ji+1,jj)  
@@ -1261,5 +1261,5 @@
       END_2D
       !
-      DO_2D( 1, 0, 1, 1 )   ! not jpj-row
+      DO_2D( 1, 1, 1, 0 )   ! not jpj-row
          IF ( phV(ji,jj) > 0._wp ) THEN   ;   pVmsk(ji,jj) = pTmsk(ji,jj  )
          ELSE                             ;   pVmsk(ji,jj) = pTmsk(ji,jj+1)  